#
# BEGIN COPYRIGHT BLOCK
# This Program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; version 2 of the License.
# 
# This Program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along with
# this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA 02111-1307 USA.
# 
# In addition, as a special exception, Red Hat, Inc. gives You the additional
# right to link the code of this Program with code not covered under the GNU
# General Public License ("Non-GPL Code") and to distribute linked combinations
# including the two, subject to the limitations in this paragraph. Non-GPL Code
# permitted under this exception must only link to the code of this Program
# through those well defined interfaces identified in the file named EXCEPTION
# found in the source code files (the "Approved Interfaces"). The files of
# Non-GPL Code may instantiate templates or use macros or inline functions from
# the Approved Interfaces without causing the resulting work to be covered by
# the GNU General Public License. Only Red Hat, Inc. may make changes or
# additions to the list of Approved Interfaces. You must obey the GNU General
# Public License in all respects for all of the Program code and other code used
# in conjunction with the Program except the Non-GPL Code covered by this
# exception. If you modify this file, you may extend this exception to your
# version of the file, but you are not obligated to do so. If you do not wish to
# provide this exception without modification, you must delete this exception
# statement from your version and license this file solely under the GPL without
# exception. 
# 
# 
# Copyright (C) 2001 Sun Microsystems, Inc. Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
#
# modules.mk: defines rules for each module that any part of the systems 
# will require in dependency lists.
#
# The current module will not be defined, you must have set the variable
# MODULE before this file is included.


NS_LIBDIR=$(BUILD_ROOT)/lib
MCOM_LIBDIR=$(BUILD_ROOT)/lib
HTTPD=$(BUILD_ROOT)/httpd
PROXY=$(BUILD_ROOT)/proxy
BATMAN=$(BUILD_ROOT)/batman
MAIL=$(BUILD_ROOT)/mailserv2
NEWS=$(BUILD_ROOT)/news
CMS=$(BUILD_ROOT)/species
ROGUE=$(BUILD_ROOT)/lw/rogue

# ------------------------------- Modules --------------------------------


ifneq ($(MODULE), LibRegex)
LIBREGEX=regex
regex:
	cd $(NS_LIBDIR)/libregex; $(MAKE) $(MFLAGS)
clean_regex:
	cd $(NS_LIBDIR)/libregex; $(MAKE) clean

depend_regex:
	cd $(NS_LIBDIR)/libregex; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibBase)
BASE=base $(LIBSI18N)
BASE_SSL=base-ssl
base:
	cd $(NS_LIBDIR)/base; $(MAKE) $(MFLAGS)
clean_base:
	cd $(NS_LIBDIR)/base; $(MAKE) clean

depend_base:
	cd $(NS_LIBDIR)/base; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibAccess)
LIBACCESS=access $(BASE) $(LIBSI18N)
libaccess:
	cd $(NS_LIBDIR)/libaccess; $(MAKE) $(MFLAGS)
clean_libaccess:
	cd $(NS_LIBDIR)/libaccess; $(MAKE) clean

depend_libaccess:
	cd $(NS_LIBDIR)/libaccess; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibLdapUtil)
LIBLDAPU=ldapu $(BASE)
libldapu:
	cd $(NS_LIBDIR)/ldaputil; $(MAKE) $(MFLAGS)
clean_libldapu:
	cd $(NS_LIBDIR)/ldaputil; $(MAKE) clean

depend_libldapu:
	cd $(NS_LIBDIR)/ldaputil; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibHttpDaemon)
HTTPDAEMON=httpdaemon
HTTPDAEMON_SSL=httpdaemon-ssl
libhttpdaemon:
	cd $(NS_LIBDIR)/httpdaemon; $(MAKE) $(MFLAGS)
clean_libhttpdaemon:
	cd $(NS_LIBDIR)/httpdaemon; $(MAKE) clean

depend_libhttpdaemon:
	cd $(NS_LIBDIR)/httpdaemon; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibFrame)
FRAME=frame $(BASE)
FRAME_SSL=frame-ssl $(BASE_SSL)
frame:
	cd $(NS_LIBDIR)/frame; $(MAKE) $(MFLAGS)
clean_frame:
	cd $(NS_LIBDIR)/frame; $(MAKE) clean

depend_frame:
	cd $(NS_LIBDIR)/frame; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibProxy)
LIBPROXY=libproxy
LIBPROXY_SSL=libproxy-ssl
libproxy:
	cd $(NS_LIBDIR)/libproxy; $(MAKE) $(MFLAGS)
clean_libproxy:
	cd $(NS_LIBDIR)/libproxy; $(MAKE) clean

depend_libproxy:
	cd $(NS_LIBDIR)/libproxy; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibSNMP)
LIBSNMP=libsnmp
LIBSNMP_SSL=libsnmp-ssl
libsnmp:
	cd $(NS_LIBDIR)/libsnmp; $(MAKE) $(MFLAGS)
clean_libsnmp:
	cd $(NS_LIBDIR)/libsnmp; $(MAKE) clean

depend_libsnmp:
	cd $(NS_LIBDIR)/libsnmp; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibSAFs)
SAFS=safs
SAFS_SSL=safs-ssl
safs:
	cd $(NS_LIBDIR)/safs; $(MAKE) $(MFLAGS)
clean_safs:
	cd $(NS_LIBDIR)/safs; $(MAKE) clean

depend_safs:
	cd $(NS_LIBDIR)/safs; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibAR)
LIBARES=ares
libares:
	cd ; $(MAKE) $(MFLAGS)
clean_libares:
	cd ; $(MAKE) clean

depend_libares:
	cd ; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), CGIUtils)
CGIUTILS=cgiutils
cgiutils:
	cd $(NS_LIBDIR)/cgiutils; $(MAKE) $(MFLAGS)
clean_cgiutils:
	cd $(NS_LIBDIR)/cgiutils; $(MAKE) clean

depend_cgiutils:
	cd $(NS_LIBDIR)/cgiutils; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibAdmin)
LIBADMIN=admin
admin:
	cd $(NS_LIBDIR)/libadmin; $(MAKE) $(MFLAGS)
clean_admin:
	cd $(NS_LIBDIR)/libadmin; $(MAKE) clean

depend_admin:
	cd $(NS_LIBDIR)/libadmin; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibAdminUtil)
#LIBADMINUTIL=adminutil
adminutil:
	cd $(NS_LIBDIR)/libadminutil; $(MAKE) $(MFLAGS)
clean_adminutil:
	cd $(NS_LIBDIR)/libadminutil; $(MAKE) clean

depend_adminutil:
	cd $(NS_LIBDIR)/libadminutil; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibCrypt)
LIBCRYPT=crypt
crypt:
	cd $(NS_LIBDIR)/libcrypt; $(MAKE) $(MFLAGS)
clean_crypt:
	cd $(NS_LIBDIR)/libcrypt; $(MAKE) clean

depend_crypt:
	cd $(NS_LIBDIR)/libcrypt; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibMessages)
LIBMESSAGES=messages
messages:
	cd $(NS_LIBDIR)/libmessages; $(MAKE) $(MFLAGS)
clean_messages:
	cd $(NS_LIBDIR)/libmessages; $(MAKE) clean

depend_messages:
	cd $(NS_LIBDIR)/libmessages; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibNSCore)
LIBNSCORE=nscore
nscore:
	cd $(NS_LIBDIR)/libnscore; $(MAKE) $(MFLAGS)
clean_nscore:
	cd $(NS_LIBDIR)/libnscore; $(MAKE) clean

depend_nscore:
	cd $(NS_LIBDIR)/libnscore; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibMsgDisp)
LIBNSCORE=msgdisp
msgdisp:
	cd $(NS_LIBDIR)/libmsgdisp; $(MAKE) $(MFLAGS)
clean_msgdisp:
	cd $(NS_LIBDIR)/libmsgdisp; $(MAKE) clean

depend_msgdisp:
	cd $(NS_LIBDIR)/libmsgdisp; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibMetaData)
LIBNSCORE=metadata
metadata:
	cd $(NS_LIBDIR)/libmetadata; $(MAKE) $(MFLAGS)
clean_metadata:
	cd $(NS_LIBDIR)/libmetadata; $(MAKE) clean

depend_metadata:
	cd $(NS_LIBDIR)/libmetadata; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibIr)
LIBNSCORE=ir
ir:
	cd $(NS_LIBDIR)/libir; $(MAKE) $(MFLAGS)
clean_ir:
	cd $(NS_LIBDIR)/libir; $(MAKE) clean

depend_ir:
	cd $(NS_LIBDIR)/libir; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibDocLdr)
LIBNSCORE=docldr
docldr:
	cd $(NS_LIBDIR)/libdocldr; $(MAKE) $(MFLAGS)
clean_docldr:
	cd $(NS_LIBDIR)/libdocldr; $(MAKE) clean

depend_docldr:
	cd $(NS_LIBDIR)/libdocldr; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibVLdr)
LIBNSCORE=vldr
vldr:
	cd $(NS_LIBDIR)/libvldr; $(MAKE) $(MFLAGS)
clean_vldr:
	cd $(NS_LIBDIR)/libvldr; $(MAKE) clean

depend_vldr:
	cd $(NS_LIBDIR)/libvldr; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibsI18N)
LIBSI18N=si18n
si18n:
	cd $(NS_LIBDIR)/libsi18n; $(MAKE) $(MFLAGS)
clean_si18n:
	cd $(NS_LIBDIR)/libsi18n; $(MAKE) clean

depend_si18n:
	cd $(NS_LIBDIR)/libsi18n; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibINN)
LIBINN=inn
inn:
	cd $(NS_LIBDIR)/libinn; $(MAKE) $(MFLAGS)
clean_inn:
	cd $(NS_LIBDIR)/libinn; $(MAKE) clean

depend_inn:
	cd $(NS_LIBDIR)/libinn; $(MAKE) depend

else
clean:
depend:
endif


#ifeq ($(ARCH), WINNT)
#ifneq ($(MODULE), LibNSPR)
#ifeq ($(DEBUG), purify)
#LIBNSPR=$(NSCP_DISTDIR)/lib/$(NSPR_BASENAME).$(LIB_SUFFIX)
#else
#LIBNSPR=$(NSCP_DISTDIR)/lib/$(NSPR_BASENAME).$(LIB_SUFFIX)
#endif
#NSPRDIR=nspr20
#DISTLIB libnspr $(BUILD_ROOT)/$(NSPRDIR)
#endif
#else
#ifneq ($(MODULE), LibNSPR)
#ifeq ($(DEBUG), purify)
#LIBNSPR=$(NSCP_DISTDIR)/lib/purelibnspr.$(LIB_SUFFIX) 
#SHLIBNSPR=$(NSCP_DISTDIR)/lib/purelibnspr$(DLL_PRESUF).$(DLL_SUFFIX) 
#else
#LIBNSPR=$(NSCP_DISTDIR)/lib/$(NSPR_BASENAME).$(LIB_SUFFIX) 
#SHLIBNSPR=$(NSCP_DISTDIR)/lib/$(NSPR_BASENAME)$(DLL_PRESUF).$(DLL_SUFFIX) 
#endif
#NSPRDIR=nspr20
#DISTLIB libnspr $(BUILD_ROOT)/$(NSPRDIR)
#endif
#endif
#
#ifneq ($(MODULE), LibSSLio)
#LIBSSLIO=$(NSCP_DISTDIR)/lib/libsslio.$(LIB_SUFFIX)
#DISTLIB libsslio $(BUILD_ROOT)/$(NSPRDIR)/lib/sslio libsslio
#endif

ifneq ($(MODULE), LibDirMon)
LIBDIRMON=$(NSCP_DISTDIR)/lib/libdirmon.$(LIB_SUFFIX)
#DISTLIB libdirmon $(BUILD_ROOT)/$(NSPRDIR)/lib/dirmon libdirmon
libdirmon: libdirmon
	cd $(BUILD_ROOT)/nspr20/lib/dirmon; $(MAKE) export $(NSDEFS)
clean_libdirmon: clean_libdirmon
	cd $(BUILD_ROOT)/nspr20/lib/dirmon; $(MAKE) clean

depend_libdirmon: depend_libdirmon
	cd $(BUILD_ROOT)/nspr20/lib/dirmon; $(MAKE) depend

else
clean: clean_libdirmon
depend: depend_libdirmon
endif


#LibAres and LibPRstrm are from NSPR20 BIN release
#ifneq ($(MODULE), LibAres)
#LIBARES=$(NSCP_DISTDIR)/lib/libares.$(LIB_SUFFIX)
#DISTLIB libares $(BUILD_ROOT)/$(NSPRDIR)/lib/arlib libares
#endif

#ifneq ($(MODULE), LibPRstrm)
#LIBPRSTRMS=$(NSCP_DISTDIR)/lib/libprstrms.$(LIB_SUFFIX)
#DISTLIB libprstrms $(BUILD_ROOT)/$(NSPRDIR)/lib/prstreams libprstrms
#endif

#ifneq ($(MODULE), LibXP)
#LIBXP=$(MCOM_LIBDIR)/xp/$(NSOBJDIR_NAME)/libxp.$(LIB_SUFFIX)
#DISTLIB libxp $(MCOM_LIBDIR)/xp libnspr
#DISTLIB libxp $(MCOM_LIBDIR)/xp 
#endif

#ifneq ($(MODULE), LibDBM)
#LIBDBM=$(MCOM_LIBDIR)/libdbm/$(NSOBJDIR_NAME)/libdbm.$(LIB_SUFFIX)
#DISTLIB libdbm $(MCOM_LIBDIR)/libdbm libnspr
#endif

ifneq ($(MODULE), LibNT)
LIBNT=$(MCOM_LIBDIR)/libnt/$(NSOBJDIR_NAME)/libnt.$(LIB_SUFFIX)
libnt:
	cd $(MCOM_LIBDIR)/libnt; $(MAKE) export $(NSDEFS)
clean_libnt:
	cd $(MCOM_LIBDIR)/libnt; $(MAKE) clean

depend_libnt:
	cd $(MCOM_LIBDIR)/libnt; $(MAKE) depend

else
clean:
depend:
endif

#ifneq ($(MODULE), LibSecurity)
#ifeq ($(SECURITY), domestic)
#WHICHA=us
#else
#WHICHA=export
#endif
#LIBSEC=$(MCOM_LIBDIR)/libsec/$(NSOBJDIR_NAME)/libsec-$(WHICHA).$(LIB_SUFFIX) $(LIBDBM) $(LIBXP)
#LIBSECNAME=libsec-$(WHICHA)
#libsec: $(LIBSECNAME)
#DISTLIB libsec-$(WHICHA) $(MCOM_LIBDIR)/libsec libnspr libdbm libxp
#endif

ifdef FORTEZZA
ifeq ($(ARCH), WINNT)
LIBSEC += $(MCOM_LIBDIR)/../dist/$(NSOBJDIR_NAME)/lib/tssp32.lib
else
FORTEZZA_DRIVER = $(MCOM_LIBDIR)/../dist/$(NSOBJDIR_NAME)/lib/libci.a
endif
LIBSEC += $(FORTEZZA_DRIVER)
endif

ifneq ($(MODULE), LibNet)
LIBNET=$(MCOM_LIBDIR)/libnet/$(NSOBJDIR_NAME)/libnet.$(LIB_SUFFIX)
libnet.$(LIB_SUFFIX):
	cd $(MCOM_LIBDIR)/libnet; $(MAKE) export $(NSDEFS)
clean_libnet.$(LIB_SUFFIX):
	cd $(MCOM_LIBDIR)/libnet; $(MAKE) clean

depend_libnet.$(LIB_SUFFIX):
	cd $(MCOM_LIBDIR)/libnet; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibCS)
LIBCS=libcs
libcs:
	cd $(NS_LIBDIR)/libcs; $(MAKE) $(MFLAGS)
clean_libcs:
	cd $(NS_LIBDIR)/libcs; $(MAKE) clean

depend_libcs:
	cd $(NS_LIBDIR)/libcs; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), LibRobotAPI)
LIBROBOTAPI=librobotapi
librobotapi:
	cd $(BATMAN)/rds/api; $(MAKE) $(MFLAGS)
clean_librobotapi:
	cd $(BATMAN)/rds/api; $(MAKE) clean

depend_librobotapi:
	cd $(BATMAN)/rds/api; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), httpdAdminHTML)
httpd-adm-html:
	cd $(HTTPD)/newadmin/html; $(MAKE) $(MFLAGS)

clean_httpd-adm-html:
	cd $(HTTPD)/newadmin/html; $(MAKE) clean

depend_httpd-adm-html:
	cd $(HTTPD)/newadmin/html; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), httpdAdminIcons)
httpd-adm-icons:
	cd $(HTTPD)/newadmin/icons; $(MAKE) $(MFLAGS)

clean_httpd-adm-icons:
	cd $(HTTPD)/newadmin/icons; $(MAKE) clean

depend_httpd-adm-icons:
	cd $(HTTPD)/newadmin/icons; $(MAKE) depend

else
clean:
depend:
endif

ifeq ($(ARCH), WINNT)
ifneq ($(MODULE), httpdAdminBin)
# the admin binaries link with the Server DLL
httpd-adm-bin:
	cd $(HTTPD)/newadmin/src; $(MAKE) $(MFLAGS)

clean_httpd-adm-bin:
	cd $(HTTPD)/newadmin/src; $(MAKE) clean

depend_httpd-adm-bin:
	cd $(HTTPD)/newadmin/src; $(MAKE) depend

else
clean:
depend:
endif
endif
ifneq ($(MODULE), httpdAdminBin)
ifneq ($(ARCH), WINNT)
httpd-adm-bin:
	cd $(HTTPD)/newadmin/src; $(MAKE) $(MFLAGS)

clean_httpd-adm-bin:
	cd $(HTTPD)/newadmin/src; $(MAKE) clean

depend_httpd-adm-bin:
	cd $(HTTPD)/newadmin/src; $(MAKE) depend

else
clean:
depend:
endif
endif

ifneq ($(MODULE), httpdInstall)
httpd-inst:
	cd $(HTTPD)/newinst; $(MAKE) $(MFLAGS)

clean_httpd-inst:
	cd $(HTTPD)/newinst; $(MAKE) clean

depend_httpd-inst:
	cd $(HTTPD)/newinst; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), httpdBinary)
httpd-bin:
	cd $(HTTPD)/src; $(MAKE) $(MFLAGS)

clean_httpd-bin:
	cd $(HTTPD)/src; $(MAKE) clean

depend_httpd-bin:
	cd $(HTTPD)/src; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), httpdExtrasDatabase)
httpd-extra-db:
	cd libxp; $(MAKE) $(MFLAGS)

clean_httpd-extra-db:
	cd libxp; $(MAKE) clean

depend_httpd-extra-db:
	cd libxp; $(MAKE) depend

else
clean:
depend:
endif


ifneq ($(MODULE), httpSubagtBinary)
http-subagt-bin:
	cd $(HTTPD)/plugins/snmp; $(MAKE) $(MFLAGS)

clean_http-subagt-bin:
	cd $(HTTPD)/plugins/snmp; $(MAKE) clean

depend_http-subagt-bin:
	cd $(HTTPD)/plugins/snmp; $(MAKE) depend

else
clean:
depend:
endif


ifneq ($(MODULE), proxyExtras)
proxy-extra:
	cd libxp; $(MAKE) $(MFLAGS)

clean_proxy-extra:
	cd libxp; $(MAKE) clean

depend_proxy-extra:
	cd libxp; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), proxyAdminHTML)
proxy-adm-html:
	cd $(PROXY)/newadmin/html; $(MAKE) $(MFLAGS)

clean_proxy-adm-html:
	cd $(PROXY)/newadmin/html; $(MAKE) clean

depend_proxy-adm-html:
	cd $(PROXY)/newadmin/html; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), proxyAdminIcons)
proxy-adm-icons:
	cd $(PROXY)/newadmin/icons; $(MAKE) $(MFLAGS)

clean_proxy-adm-icons:
	cd $(PROXY)/newadmin/icons; $(MAKE) clean

depend_proxy-adm-icons:
	cd $(PROXY)/newadmin/icons; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), proxyAdminBin)
proxy-adm-bin:
	cd $(PROXY)/newadmin/src; $(MAKE) $(MFLAGS)

clean_proxy-adm-bin:
	cd $(PROXY)/newadmin/src; $(MAKE) clean

depend_proxy-adm-bin:
	cd $(PROXY)/newadmin/src; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), proxyInstallHTML)
proxy-inst-html:
	cd $(PROXY)/newinst/html; $(MAKE) $(MFLAGS)

clean_proxy-inst-html:
	cd $(PROXY)/newinst/html; $(MAKE) clean

depend_proxy-inst-html:
	cd $(PROXY)/newinst/html; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), proxyInstallBin)
proxy-inst-bin:
	cd $(PROXY)/newinst/src; $(MAKE) $(MFLAGS)

clean_proxy-inst-bin:
	cd $(PROXY)/newinst/src; $(MAKE) clean

depend_proxy-inst-bin:
	cd $(PROXY)/newinst/src; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), proxyBinary)
proxy-bin:
	cd $(PROXY)/src; $(MAKE) $(MFLAGS)

clean_proxy-bin:
	cd $(PROXY)/src; $(MAKE) clean

depend_proxy-bin:
	cd $(PROXY)/src; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), admservBinary)
admin-server: libnspr frame safs libsnmp libadmin libadminutil libsec-$(WHICHA)
	cd $(BUILD_ROOT)/admserv; $(MAKE) $(MFLAGS)

clean_admin-server: clean_libnspr clean_frame clean_safs clean_libsnmp clean_libadmin clean_libadminutil clean_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/admserv; $(MAKE) clean

depend_admin-server: depend_libnspr depend_frame depend_safs depend_libsnmp depend_libadmin depend_libadminutil depend_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/admserv; $(MAKE) depend

else
clean: clean_libnspr clean_frame clean_safs clean_libsnmp clean_libadmin clean_libadminutil clean_libsec-$(WHICHA)
depend: depend_libnspr depend_frame depend_safs depend_libsnmp depend_libadmin depend_libadminutil depend_libsec-$(WHICHA)
endif

ifneq ($(MODULE), mailServer)
mail-server: libnspr
	cd $(BUILD_ROOT)/mailserv2/code; $(MAKE) $(MFLAGS)

clean_mail-server: clean_libnspr
	cd $(BUILD_ROOT)/mailserv2/code; $(MAKE) clean

depend_mail-server: depend_libnspr
	cd $(BUILD_ROOT)/mailserv2/code; $(MAKE) depend

else
clean: clean_libnspr
depend: depend_libnspr
endif

ifneq ($(MODULE), mailAdmin)
mail-admin: libnspr frame libsec-$(WHICHA) admin
	cd $(BUILD_ROOT)/mailserv2/admin; $(MAKE) $(MFLAGS)

clean_mail-admin: clean_libnspr clean_frame clean_libsec-$(WHICHA) clean_admin
	cd $(BUILD_ROOT)/mailserv2/admin; $(MAKE) clean

depend_mail-admin: depend_libnspr depend_frame depend_libsec-$(WHICHA) depend_admin
	cd $(BUILD_ROOT)/mailserv2/admin; $(MAKE) depend

else
clean: clean_libnspr clean_frame clean_libsec-$(WHICHA) clean_admin
depend: depend_libnspr depend_frame depend_libsec-$(WHICHA) depend_admin
endif

ifneq ($(MODULE), mailInstall)
mail-inst: libnspr cgiutils regex frame
	cd $(BUILD_ROOT)/mailserv2/install; $(MAKE) $(MFLAGS)

clean_mail-inst: clean_libnspr clean_cgiutils clean_regex clean_frame
	cd $(BUILD_ROOT)/mailserv2/install; $(MAKE) clean

depend_mail-inst: depend_libnspr depend_cgiutils depend_regex depend_frame
	cd $(BUILD_ROOT)/mailserv2/install; $(MAKE) depend

else
clean: clean_libnspr clean_cgiutils clean_regex clean_frame
depend: depend_libnspr depend_cgiutils depend_regex depend_frame
endif

ifneq ($(MODULE), nnrpdBinary)
news-nnrpd: libnspr inn base libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/nnrpd; $(MAKE) $(MFLAGS)

clean_news-nnrpd: clean_libnspr clean_inn clean_base clean_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/nnrpd; $(MAKE) clean

depend_news-nnrpd: depend_libnspr depend_inn depend_base depend_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/nnrpd; $(MAKE) depend

else
clean: clean_libnspr clean_inn clean_base clean_libsec-$(WHICHA)
depend: depend_libnspr depend_inn depend_base depend_libsec-$(WHICHA)
endif

ifneq ($(MODULE), inndBinary)
news-innd: libnspr inn base libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/innd; $(MAKE) $(MFLAGS)

clean_news-innd: clean_libnspr clean_inn clean_base clean_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/innd; $(MAKE) clean

depend_news-innd: depend_libnspr depend_inn depend_base depend_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/innd; $(MAKE) depend

else
clean: clean_libnspr clean_inn clean_base clean_libsec-$(WHICHA)
depend: depend_libnspr depend_inn depend_base depend_libsec-$(WHICHA)
endif

ifneq ($(MODULE), innBackEnds)
news-backends: libnspr inn base libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/backends; $(MAKE) $(MFLAGS)

clean_news-backends: clean_libnspr clean_inn clean_base clean_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/backends; $(MAKE) clean

depend_news-backends: depend_libnspr depend_inn depend_base depend_libsec-$(WHICHA)
	cd $(BUILD_ROOT)/news/backends; $(MAKE) depend

else
clean: clean_libnspr clean_inn clean_base clean_libsec-$(WHICHA)
depend: depend_libnspr depend_inn depend_base depend_libsec-$(WHICHA)
endif

ifneq ($(MODULE), innExpire)
news-expire: libnspr inn
	cd $(BUILD_ROOT)/news/expire; $(MAKE) $(MFLAGS)

clean_news-expire: clean_libnspr clean_inn
	cd $(BUILD_ROOT)/news/expire; $(MAKE) clean

depend_news-expire: depend_libnspr depend_inn
	cd $(BUILD_ROOT)/news/expire; $(MAKE) depend

else
clean: clean_libnspr clean_inn
depend: depend_libnspr depend_inn
endif

ifneq ($(MODULE), innFrontEnds)
news-frontends: libnspr inn
	cd $(BUILD_ROOT)/news/frontends; $(MAKE) $(MFLAGS)

clean_news-frontends: clean_libnspr clean_inn
	cd $(BUILD_ROOT)/news/frontends; $(MAKE) clean

depend_news-frontends: depend_libnspr depend_inn
	cd $(BUILD_ROOT)/news/frontends; $(MAKE) depend

else
clean: clean_libnspr clean_inn
depend: depend_libnspr depend_inn
endif

ifneq ($(MODULE), innInstall)
news-install: libnspr inn admin base
	cd $(BUILD_ROOT)/news/newinst; $(MAKE) $(MFLAGS)

clean_news-install: clean_libnspr clean_inn clean_admin clean_base
	cd $(BUILD_ROOT)/news/newinst; $(MAKE) clean

depend_news-install: depend_libnspr depend_inn depend_admin depend_base
	cd $(BUILD_ROOT)/news/newinst; $(MAKE) depend

else
clean: clean_libnspr clean_inn clean_admin clean_base
depend: depend_libnspr depend_inn depend_admin depend_base
endif

ifneq ($(MODULE), innAdmin)
news-admin: libnspr inn admin base
	cd $(BUILD_ROOT)/news/admin; $(MAKE) $(MFLAGS)

clean_news-admin: clean_libnspr clean_inn clean_admin clean_base
	cd $(BUILD_ROOT)/news/admin; $(MAKE) clean

depend_news-admin: depend_libnspr depend_inn depend_admin depend_base
	cd $(BUILD_ROOT)/news/admin; $(MAKE) depend

else
clean: clean_libnspr clean_inn clean_admin clean_base
depend: depend_libnspr depend_inn depend_admin depend_base
endif

ifneq ($(MODULE), innSiteFiles)
news-site: libnspr inn
	cd $(BUILD_ROOT)/news/site; $(MAKE) $(MFLAGS)

clean_news-site: clean_libnspr clean_inn
	cd $(BUILD_ROOT)/news/site; $(MAKE) clean

depend_news-site: depend_libnspr depend_inn
	cd $(BUILD_ROOT)/news/site; $(MAKE) depend

else
clean: clean_libnspr clean_inn
depend: depend_libnspr depend_inn
endif


ifneq ($(MODULE), batmanDS)
batman-ds: libcs
	cd $(BATMAN)/ds; $(MAKE) $(MFLAGS)

clean_batman-ds: clean_libcs
	cd $(BATMAN)/ds; $(MAKE) clean

depend_batman-ds: depend_libcs
	cd $(BATMAN)/ds; $(MAKE) depend

else
clean: clean_libcs
depend: depend_libcs
endif

ifneq ($(MODULE), batmanClient)
batman-client: libcs
	cd $(BATMAN)/client; $(MAKE) $(MFLAGS)

clean_batman-client: clean_libcs
	cd $(BATMAN)/client; $(MAKE) clean

depend_batman-client: depend_libcs
	cd $(BATMAN)/client; $(MAKE) depend

else
clean: clean_libcs
depend: depend_libcs
endif

ifneq ($(MODULE), batmanRDS)
batman-rds: libnspr libcs regex libxp libdbm libnet.$(LIB_SUFFIX) libsec-$(WHICHA) base frame
	cd $(BATMAN)/rds; $(MAKE) $(MFLAGS)

clean_batman-rds: clean_libnspr clean_libcs clean_regex clean_libxp clean_libdbm clean_libnet.$(LIB_SUFFIX) clean_libsec-$(WHICHA) clean_base clean_frame
	cd $(BATMAN)/rds; $(MAKE) clean

depend_batman-rds: depend_libnspr depend_libcs depend_regex depend_libxp depend_libdbm depend_libnet.$(LIB_SUFFIX) depend_libsec-$(WHICHA) depend_base depend_frame
	cd $(BATMAN)/rds; $(MAKE) depend

else
clean: clean_libnspr clean_libcs clean_regex clean_libxp clean_libdbm clean_libnet.$(LIB_SUFFIX) clean_libsec-$(WHICHA) clean_base clean_frame
depend: depend_libnspr depend_libcs depend_regex depend_libxp depend_libdbm depend_libnet.$(LIB_SUFFIX) depend_libsec-$(WHICHA) depend_base depend_frame
endif

ifneq ($(MODULE), batmanMiniRDS)
batman-minirds:
	cd $(BATMAN)/minirds; $(MAKE) $(MFLAGS)

clean_batman-minirds:
	cd $(BATMAN)/minirds; $(MAKE) clean

depend_batman-minirds:
	cd $(BATMAN)/minirds; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), batmanDBA)
batman-dba: libcs libdbm
	cd $(BATMAN)/dba; $(MAKE) $(MFLAGS)

clean_batman-dba: clean_libcs clean_libdbm
	cd $(BATMAN)/dba; $(MAKE) clean

depend_batman-dba: depend_libcs depend_libdbm
	cd $(BATMAN)/dba; $(MAKE) depend

else
clean: clean_libcs clean_libdbm
depend: depend_libcs depend_libdbm
endif

ifneq ($(MODULE), batmanTaxonomy)
batman-taxonomy: libcs
	cd $(BATMAN)/tax; $(MAKE) $(MFLAGS)

clean_batman-taxonomy: clean_libcs
	cd $(BATMAN)/tax; $(MAKE) clean

depend_batman-taxonomy: depend_libcs
	cd $(BATMAN)/tax; $(MAKE) depend

else
clean: clean_libcs
depend: depend_libcs
endif

ifneq ($(MODULE), httpd-extras)
httpd-extras:
	cd $(HTTPD)/extras; $(MAKE) $(MFLAGS)

clean_httpd-extras:
	cd $(HTTPD)/extras; $(MAKE) clean

depend_httpd-extras:
	cd $(HTTPD)/extras; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), httpd-mc-icons)
httpd-mc-icons:
	cd $(BUILD_ROOT)/mc-icons; $(MAKE) $(MFLAGS)

clean_httpd-mc-icons:
	cd $(BUILD_ROOT)/mc-icons; $(MAKE) clean

depend_httpd-mc-icons:
	cd $(BUILD_ROOT)/mc-icons; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), cms-rogue)
cms-rogue:
	cd $(ROGUE); $(MAKE) $(MFLAGS)

clean_cms-rogue:
	cd $(ROGUE); $(MAKE) clean

depend_cms-rogue:
	cd $(ROGUE); $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), cms-cert)
cms-cert:
	cd $(BUILD_ROOT)/certsvc; $(MAKE) $(MFLAGS)

clean_cms-cert:
	cd $(BUILD_ROOT)/certsvc; $(MAKE) clean

depend_cms-cert:
	cd $(BUILD_ROOT)/certsvc; $(MAKE) depend

else
clean:
depend:
endif

ifneq ($(MODULE), ns-config)
ns-config:
	cd $(BUILD_ROOT)/config; $(MAKE) $(MFLAGS)

clean_ns-config:
	cd $(BUILD_ROOT)/config; $(MAKE) clean

depend_ns-config:
	cd $(BUILD_ROOT)/config; $(MAKE) depend

else
clean:
depend:
endif

# httpd-bin first so the dll gets built
ifeq ($(ARCH), WINNT)
httpd: httpd-adm-bin httpd-adm-html httpd-adm-icons httpd-inst
clean_httpd: clean_httpd-adm-bin clean_httpd-adm-html clean_httpd-adm-icons clean_httpd-inst
depend_httpd: depend_httpd-adm-bin depend_httpd-adm-html depend_httpd-adm-icons depend_httpd-inst
else
httpd: httpd-bin
clean_httpd: clean_httpd-bin
depend_httpd: depend_httpd-bin
endif

proxy: proxy-bin proxy-adm-html proxy-adm-bin proxy-adm-icons proxy-inst-html proxy-inst-bin
clean_proxy: clean_proxy-bin clean_proxy-adm-html clean_proxy-adm-bin clean_proxy-adm-icons clean_proxy-inst-html clean_proxy-inst-bin
depend_proxy: depend_proxy-bin depend_proxy-adm-html depend_proxy-adm-bin depend_proxy-adm-icons depend_proxy-inst-html depend_proxy-inst-bin

mail: mail-server mail-admin mail-inst
clean_mail: clean_mail-server clean_mail-admin clean_mail-inst
depend_mail: depend_mail-server depend_mail-admin depend_mail-inst

news: news-backends news-expire news-frontends news-innd news-install news-admin news-nnrpd news-site
clean_news: clean_news-backends clean_news-expire clean_news-frontends clean_news-innd clean_news-install clean_news-admin clean_news-nnrpd clean_news-site
depend_news: depend_news-backends depend_news-expire depend_news-frontends depend_news-innd depend_news-install depend_news-admin depend_news-nnrpd depend_news-site

admserv: admin-server
clean_admserv: clean_admin-server
depend_admserv: depend_admin-server

batman: batman-rds batman-minirds batman-ds batman-client batman-taxonomy
clean_batman: clean_batman-rds clean_batman-minirds clean_batman-ds clean_batman-client clean_batman-taxonomy
depend_batman: depend_batman-rds depend_batman-minirds depend_batman-ds depend_batman-client depend_batman-taxonomy


cms-httpd: httpd-adm-bin httpd-adm-html httpd-adm-icons httpd-mc-icons httpd-extras httpd-inst
clean_cms-httpd: clean_httpd-adm-bin clean_httpd-adm-html clean_httpd-adm-icons clean_httpd-mc-icons clean_httpd-extras clean_httpd-inst
depend_cms-httpd: depend_httpd-adm-bin depend_httpd-adm-html depend_httpd-adm-icons depend_httpd-mc-icons depend_httpd-extras depend_httpd-inst
# base frame admin libaccess cgiutils  
cms-server: ns-config libnspr libdbm libsec-$(WHICHA) libxp cms-rogue cms-cert
clean_cms-server: clean_ns-config clean_libnspr clean_libdbm clean_libsec-$(WHICHA) clean_libxp clean_cms-rogue clean_cms-cert
depend_cms-server: depend_ns-config depend_libnspr depend_libdbm depend_libsec-$(WHICHA) depend_libxp depend_cms-rogue depend_cms-cert
